using System;
using Microsoft.EntityFrameworkCore.Migrations;

#nullable disable

namespace BMA.EHR.Infrastructure.Migrations
{
    /// <inheritdoc />
    public partial class ADDtableInsigniaManageOrganiations : Migration
    {
        /// <inheritdoc />
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropColumn(
                name: "Type",
                table: "InsigniaManages");

            migrationBuilder.CreateTable(
                name: "InsigniaManageOrganiations",
                columns: table => new
                {
                    Id = table.Column<Guid>(type: "char(36)", nullable: false, comment: "PrimaryKey", collation: "ascii_general_ci"),
                    CreatedAt = table.Column<DateTime>(type: "datetime(6)", nullable: false, comment: "สร้างข้อมูลเมื่อ"),
                    CreatedUserId = table.Column<string>(type: "varchar(40)", maxLength: 40, nullable: false, comment: "User Id ที่สร้างข้อมูล")
                        .Annotation("MySql:CharSet", "utf8mb4"),
                    LastUpdatedAt = table.Column<DateTime>(type: "datetime(6)", nullable: true, comment: "แก้ไขข้อมูลล่าสุดเมื่อ"),
                    LastUpdateUserId = table.Column<string>(type: "varchar(40)", maxLength: 40, nullable: false, comment: "User Id ที่แก้ไขข้อมูลล่าสุด")
                        .Annotation("MySql:CharSet", "utf8mb4"),
                    CreatedFullName = table.Column<string>(type: "varchar(200)", maxLength: 200, nullable: false, comment: "ชื่อ User ที่สร้างข้อมูล")
                        .Annotation("MySql:CharSet", "utf8mb4"),
                    LastUpdateFullName = table.Column<string>(type: "varchar(200)", maxLength: 200, nullable: false, comment: "ชื่อ User ที่แก้ไขข้อมูลล่าสุด")
                        .Annotation("MySql:CharSet", "utf8mb4"),
                    Total = table.Column<int>(type: "int", nullable: false, comment: "จำนวนทั้งหมด"),
                    OrganizationOrganizationId = table.Column<Guid>(type: "char(36)", nullable: false, collation: "ascii_general_ci"),
                    InsigniaManageId = table.Column<Guid>(type: "char(36)", nullable: false, collation: "ascii_general_ci")
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_InsigniaManageOrganiations", x => x.Id);
                    table.ForeignKey(
                        name: "FK_InsigniaManageOrganiations_InsigniaManages_InsigniaManageId",
                        column: x => x.InsigniaManageId,
                        principalTable: "InsigniaManages",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_InsigniaManageOrganiations_OrganizationOrganizations_Organiz~",
                        column: x => x.OrganizationOrganizationId,
                        principalTable: "OrganizationOrganizations",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                })
                .Annotation("MySql:CharSet", "utf8mb4");

            migrationBuilder.CreateIndex(
                name: "IX_InsigniaManageOrganiations_InsigniaManageId",
                table: "InsigniaManageOrganiations",
                column: "InsigniaManageId");

            migrationBuilder.CreateIndex(
                name: "IX_InsigniaManageOrganiations_OrganizationOrganizationId",
                table: "InsigniaManageOrganiations",
                column: "OrganizationOrganizationId");
        }

        /// <inheritdoc />
        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropTable(
                name: "InsigniaManageOrganiations");

            migrationBuilder.AddColumn<string>(
                name: "Type",
                table: "InsigniaManages",
                type: "longtext",
                nullable: false,
                comment: "ประเภทเครื่องราช")
                .Annotation("MySql:CharSet", "utf8mb4");
        }
    }
}
